]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- utf8
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 %__rm                   /bin/rm --interactive=never
12
13 # Build system path macros.
14 #
15 %__autoconf             autoconf %{?debug:-Wall}
16 %__automake             automake -a -c -f --foreign
17 %__autopoint            autopoint --force
18
19 %__gettextize { \
20         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
21                 gettextize --copy --force --no-changelog; \
22         else \
23                 gettextize --copy --force --no-changelog --intl; \
24         fi; \
25         if [ ! -f po/Makevars ]; then \
26                 cp -f po/Makevars{.template,}; \
27         fi; \
28 }
29
30 %__glib_gettextize      glib-gettextize --copy --force
31 %__gnome_doc_common     gnome-doc-common --copy
32 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
33 %__gtkdocize            gtkdocize --copy
34 %__intltoolize          intltoolize --copy --force
35 %__libtoolize           libtoolize --copy --force
36
37 #       Path to top of build area.
38 %_topdir                %(test -d ../SPECS && (cd ..; pwd) || echo $HOME/rpm)
39
40 #       The number of cvs changelog entries kept when building package.
41 %_buildchangelogtruncate 20
42
43 %dependencytracking     %{nil}
44
45 #       Relations between package names that cause dependency loops
46 #       with legacy packages that cannot be fixed. Relations are
47 #       specified as
48 #               p>q
49 #       where package p has a Requires: on something that package q Provides:
50 #
51 # XXX   Note: that there cannot be any whitespace within the string "p>q",
52 #       and that both p and q are package names (i.e. no version/release).
53 %_dependency_whiteout   %{nil}
54
55 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
58
59 #-----------------------------------------------------------------
60 #
61 # (re)definition of %{rpm*flags} with %filterout_* support
62 # BuildRequires:        awk
63 # BuildRequires:        rpmbuild(macros) >= 1.315
64 #
65 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
66 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
67 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
68 # %rpmldflags   = %optldflags - %filterout_ld
69 #
70 # Regular expressions are supported, but to avoid some character be treated
71 # as regular expression it must be escaped twice.
72
73 %filter_out                                             \
74         for (i = 1; i in I; i++) {      A=0;    \
75                 for (f in F) {                          \
76                         if (I[i] ~ "^" F[f] "$") A=1;   \
77                 };                                                      \
78                 if (!A) printf(I[i] FS);        \
79         }
80
81 %rpmcflags %(awk 'BEGIN {
82         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
83         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
84         %{filter_out}
85 }')
86
87 %rpmcxxflags %(awk 'BEGIN {
88         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
90         %{filter_out}
91 }')
92
93 %rpmldflags %(awk 'BEGIN {
94         split("%{?optldflags}",I);
95         split("%{?filterout_ld}",F)
96         %{filter_out}
97 }')
98
99 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100 # but, don't use it, better use gcc as linker
101 %ld_rpmldflags %(awk 'BEGIN {
102         split("%{rpmldflags}",F);
103         for (f in F) {
104                 s = F[f];
105                 if (s ~ /^-Wl,/) {
106                         s = substr(s,5);
107                         gsub(/,/," ",s);
108                 };
109                 printf(s FS);
110         };
111 }')
112
113 #-----------------------------------------------------------------
114 %configure2_13 { \
115  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
118  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
119  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
120  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
121  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
122  %{?__cc:CC="%{__cc}" ; export CC ; } \
123  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
124  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
125         --host=%{_target_platform} \
126         --prefix=%{_prefix} \
127         --exec-prefix=%{_exec_prefix} \
128         --bindir=%{_bindir} \
129         --sbindir=%{_sbindir} \
130         --sysconfdir=%{_sysconfdir} \
131         --datadir=%{_datadir} \
132         --includedir=%{_includedir} \
133         --libdir=%{_libdir} \
134         --libexecdir=%{_libexecdir} \
135         --localstatedir=%{_localstatedir} \
136         --sharedstatedir=%{_sharedstatedir} \
137         --mandir=%{_mandir} \
138         --infodir=%{_infodir} \
139         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
140         %{dependencytracking} \
141 }
142
143 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144 %__cmake        /usr/bin/cmake
145 %cmake { \
146 CC="%{__cc}" \
147 CXX="%{__cxx}" \
148 CFLAGS="%{rpmcflags}" \
149 CXXFLAGS="%{rpmcxxflags}" \
150 %{__cmake} \
151 }
152
153 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
154 %__scons        /usr/bin/scons
155 %scons { \
156 %{__scons} \
157         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158         CFLAGS="${CFLAGS:-%rpmcflags}" \
159         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160         FFLAGS="${FFLAGS:-%rpmcflags}" \
161         CPPFLAGS="${CPPFLAGS:-}" \
162         %{?__cc:CC="%{__cc}"} \
163         %{?__cxx:CXX="%{__cxx}"} \
164         libsuffix=%{_lib} \
165         prefix=%{_prefix} \
166 }
167
168 # waf. see waf.spec
169 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
170 %__waf  /usr/bin/waf
171 %waf { \
172 CC="%{__cc}" \
173 CXX="%{__cxx}" \
174 CPP="%{__cpp}" \
175 CFLAGS="%{rpmcflags}" \
176 CXXFLAGS="%{rpmcxxflags}" \
177 %{__waf} \
178 }
179
180 #----------------------------------------------------------------
181 #%configure_cache 0
182 %configure_cache_file   %{buildroot}.configure.cache
183
184 %configure {./configure \
185         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186         CFLAGS="${CFLAGS:-%rpmcflags}" \
187         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
188         FFLAGS="${FFLAGS:-%rpmcflags}" \
189         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
190         CPPFLAGS="${CPPFLAGS:-}" \
191         %{?__cc:CC="%{__cc}"} \
192         %{?__cxx:CXX="%{__cxx}"} \
193         --host=%{_target_platform} \
194         --build=%{_target_platform} \
195         --prefix=%{_prefix} \
196         --exec-prefix=%{_exec_prefix} \
197         --bindir=%{_bindir} \
198         --sbindir=%{_sbindir} \
199         --sysconfdir=%{_sysconfdir} \
200         --datadir=%{_datadir} \
201         --includedir=%{_includedir} \
202         --libdir=%{_libdir} \
203         --libexecdir=%{_libexecdir} \
204         --localstatedir=%{_localstatedir} \
205         --sharedstatedir=%{_sharedstatedir} \
206         --mandir=%{_mandir} \
207         --infodir=%{_infodir} \
208         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
209         %{dependencytracking} \
210         %{?configure_cache:--cache-file=%{configure_cache_file}} \
211 }
212
213 # overload to insert debuginfo package
214 %prep \
215 %if 0%{?_enable_debug_packages}\
216 %{debug_package}\
217 %endif\
218 %%prep\
219 %{nil}
220
221 # Location of autoconf macros
222 %_aclocaldir    %(aclocal --print-ac-dir)
223
224 # Location of omf files
225 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
226
227 # Location of pkgconfig files
228 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
229
230 # Location of desktop files
231 %_desktopdir    /usr/share/applications
232 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
233
234 # Location of pixmaps for applnk/desktop files
235 %_pixmapsdir    /usr/share/pixmaps
236
237 # Location of themable icons for applnk/desktop files
238 %_iconsdir      /usr/share/icons
239
240 # Location of fonts directories
241 %_fontsdir      /usr/share/fonts
242
243 # Location of Gtk and associated libraries documentation
244 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
245
246 # Location of KDE documentation
247 %_kdedocdir     %{_defaultdocdir}/kde/HTML
248
249 # unsermake script
250 %__unsermake /usr/share/unsermake/unsermake
251
252 # Current date
253 %date           %(LC_ALL="C" date +"%a %b %d %Y")
254
255 # tmp directory
256 %tmpdir         %(echo "${TMPDIR:-/tmp}")
257
258 # Example files, programs, scripts...
259 %_examplesdir   /usr/src/examples
260
261 # Alternative kernel type/version
262 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
263
264 # The directory holding Linux kernel sources
265 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
266
267 # If non-empty "debug" macro defined, add "dbg" suffix to release number
268 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
269
270 # Requires name = version-release
271 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
272
273 %releq_kernel()                 %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
274 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
275 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
276 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
277 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
278 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
279
280 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
281 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
282
283 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
284
285 # kernel version-release handling
286 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
287 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
288 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
289 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
290 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
291
292 # sgml macros
293 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
294 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
295 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
296 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
297 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
298 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
299 %docbook_sgmlcat_fix() { for l in \
300 '' \
301 '  -- default decl --' \
302 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
303 '  -- hacks for opensp --' \
304 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
305 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
306 '' \
307 ; do echo $l; done >> %1 \
308 }
309
310 # vim - "
311
312 # minimum file size needed for compressed documents.
313 # just smaller files than this get larger when compressed.
314 # some stats:
315 # - 0 byte file compressed was 25 bytes .gz
316 # - 39 byte file was compressed as 57
317 # - with test/test.spec@man 158 byte file was compressed also 158
318 %_min_compress_bytes    159
319
320 #-----------------------------------------------------------------
321 # find and gzip all files in %{_mandir} and %{infodir}
322 #
323 # Requires: xargs, find
324 #
325 #%no_install_post_compress_docs 1
326 %__spec_install_post_compress_docs { \
327 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
328         for i in /usr/share/man /usr/X11R6/man; do \
329                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
330                         echo "Compress man pages: $i"; \
331                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
332                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
333                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
334                                 m=$(readlink $a); \
335                                 rm -f $a; \
336                                 echo .so ${m##*/} > $a; \
337                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
338                         done; \
339                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
340                 fi; \
341         done; \
342         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
343                 echo "Compress info pages: %{_infodir}"; \
344                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
345                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
346                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
347         fi; \
348 }; __spec_install_post_compress_docs } }
349
350 #-----------------------------------------------------------------
351 # Strip executable binaries and shared object files
352 #
353 # Requires: find, awk, strip, cut, xargs
354 #
355 # Special macros which affect this process:
356 #%no_install_post_strip 1               # disable stripping at all
357 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
358 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
359 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
360 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
361 #
362 %__spec_install_post_strip {%{!?debug: \
363 %{!?no_install_post_strip:__spec_install_post_strip() { \
364 if [ -d "$RPM_BUILD_ROOT" ]; then \
365         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
366                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
367                 if [ "$modulelist" ]; then \
368                         modulecount=$(echo "$modulelist" | wc -l); \
369                         printf "Stripping %d kernel modules..." $modulecount; \
370                         echo "$modulelist" | xargs -l512 chmod u+w; \
371                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
372                         echo "DONE"; \
373                 fi; \
374         fi; \
375         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}`; \
376         if [ -n "$filelist" ]; then \
377                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
378                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
379                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
380                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
381                 if [ -n "$elfexelist" ]; then \
382                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
383                         chmod u+w $elfexelist; \
384                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
385                         echo "DONE"; \
386                 fi; \
387                 if [ -n "$elfsharedlist" ]; then \
388                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
389                         chmod u+w $elfsharedlist; \
390                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
391                         echo "DONE"; \
392                 fi; \
393                 if [ -n "$archiveslist" ]; then \
394                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
395                         chmod u+w $archiveslist; \
396                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
397                         echo "DONE"; \
398                 fi; \
399         fi; \
400     filelist_all=%{?_autostripall:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}"`}; \
401     filelist_unneeded=%{?_autostripunneeded:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}"`}; \
402     filelist_debug=%{?_autostripdebug:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}"`}; \
403         if [ -n "$filelist_all" ]; then \
404                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
405                 chmod u+w $filelist_all; \
406                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
407                 echo "DONE"; \
408         fi; \
409         if [ -n "$filelist_unneeded" ]; then \
410                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
411                 chmod u+w $filelist_unneeded; \
412                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
413                 echo "DONE"; \
414         fi; \
415         if [ -n "$filelist_debug" ]; then \
416                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
417                 chmod u+w $filelist_debug; \
418                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
419                 echo "DONE"; \
420         fi; \
421 fi; }; __spec_install_post_strip } } }
422
423 #-----------------------------------------------------------------
424 # remove all RPATH from executable binaries and shared object files
425 #
426 # Requires: find, awk, cut, xargs, chrpath, uname
427 #
428 # Special macros which affect this process
429 #%no_install_post_chrpath       1       # disable chrpath at all
430 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
431 #
432 %__spec_install_post_chrpath {%{!?debug: \
433 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
434 if [ -d "$RPM_BUILD_ROOT" ]; then \
435         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
436         if [ -n "$files" ]; then \
437                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
438         fi; \
439         if [ -n "$objs" ]; then \
440                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
441                 echo "$objs" | \
442                 while read file; do \
443                         rpath= ; \
444                         chmod u+w "$file"; \
445                         for dir in `chrpath -l "$file" | \
446                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
447                                         case $dir in \
448                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
449                                                 echo "remove-rpath: $dir in $file"; \
450                                                 ;; \
451                                         * ) \
452                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
453                                                 else rpath="$rpath:$dir" ; fi ; \
454                                                 ;; \
455                                         esac ; \
456                         done ; \
457                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
458                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
459                 done; \
460         fi; \
461 fi; }; __spec_install_post_chrpath } } }
462
463 #-----------------------------------------------------------------
464 # Find and gzip all kernel modules
465 #
466 # Requires: find
467 #
468 #%no_install_post_compress_modules      1
469 %__spec_install_post_compress_modules { \
470 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
471         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
472                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
473                 if [ "$q" ]; then \
474                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
475                         echo "$q" | xargs -r %{__gzip} -9nf; \
476                         echo "DONE"; \
477                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
478                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
479                 fi; \
480         fi; \
481 }; __spec_install_post_compress_modules } }
482
483 # Remove common Perl files we don't package
484 %__spec_install_post_perl_clean {\
485 %{!?no_install_post_perl_clean: \
486 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
487 } }
488
489 #-----------------------------------------------------------------
490 # Update GConf2 schemas
491 #
492 # Requires: GConf2
493 #
494 %gconf_schema_install() \
495         umask 022; \
496         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
497         %{nil}
498
499 %gconf_schema_uninstall() \
500 if [ $1 = 0 ]; then \
501         umask 022; \
502         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
503 fi \
504 %{nil}
505
506 #-----------------------------------------------------------------
507 # Update desktop MIME database
508 # requires: desktop-file-utils
509 #
510 %update_desktop_database_post() {{ \
511         umask 022; \
512         /usr/bin/update-desktop-database -q; \
513 }} \
514 %{nil}
515
516 %update_desktop_database_postun() {{ \
517 if [ $1 = 0 ]; then \
518         umask 022; \
519         /usr/bin/update-desktop-database -q; \
520 fi \
521 }} \
522 %{nil}
523
524 #-----------------------------------------------------------------
525 # Update shared MIME info database
526 # requires: shared-mime-info
527 #
528 %update_mime_database() {{ \
529         umask 022; \
530         /usr/bin/update-mime-database %{_datadir}/mime; \
531 }} \
532 %{nil}
533
534 #-----------------------------------------------------------------
535 # Update icon cache
536 # requires: gtk+
537 #
538 %update_icon_cache() {{ \
539         umask 022; \
540         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
541 }} \
542 %{nil}
543
544 #-----------------------------------------------------------------
545 # Update scrollkeeper database
546 # requires: scrollkeeper
547 #
548 %scrollkeeper_update_post() \
549         /usr/bin/scrollkeeper-update -q; \
550         %{nil}
551
552 %scrollkeeper_update_postun() \
553 if [ $1 = 0 ]; then \
554         /usr/bin/scrollkeeper-update -q; \
555 fi \
556 %{nil}
557
558 #-----------------------------------------------------------------
559 # post %install sequence:
560 # - autodeps exceptions
561 # - compress all man and info pages,
562 # - strip all ELF executables and ELF shared objects if not %debug.
563 # - compress kernel modules if any
564
565 ###################################################################
566 # Requires/Provides automation
567 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
568 #
569 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
570 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
571 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
572 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
573 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
574 #%_noautocompressdoc    %{nil}
575 #
576 %_missing_doc_files_terminate_build     1%{nil}
577 %_unpackaged_files_terminate_build      %{nil}
578 # (X)emacs support
579 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
580 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
581 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
582
583 %__php_provides %{nil}
584 %__php_requires %{nil}
585 %__perl_provides %{nil}
586 %__perl_requires %{nil}
587 %__mono_provides %{nil}
588 %__mono_requires %{nil}
589
590 # Perl specific macro definitions.
591 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
592 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
593 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
594 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
595 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
596 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
597
598 # Ruby
599 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
600 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
601 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
602 %ruby_vendorarchdir     %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
603 %ruby_vendorlibdir      %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
604 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
605 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
606 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
607 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
608 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
609
610 %php_pear_dir           /usr/share/pear
611 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
612 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
613 %php_includedir         %(php-config --include-dir 2>/dev/null || echo ERROR)
614
615 # extract php/zend api versions
616 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
617 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
618 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
619 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
620 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
621 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
622 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
623
624 # helper macro
625 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
626
627 # macros for public use
628 # for php extensions (php-pecl)
629 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
630 %{__php_api_requires zend_module_api} \
631 %{__php_api_requires -v %php_major_version debug php_debug} \
632 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
633
634 # for zend extensions
635 %requires_zend_extension %{__php_api_requires zend_module_api} \
636 %{__php_api_requires zend_extension_api} \
637 %{__php_api_requires -v %php_major_version debug php_debug} \
638 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
639
640 # for php pdo modules (php-pecl-PDO_*)
641 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
642
643 # for using PHP post scripts. for PHP >= 5.0
644 %php_webserver_restart \
645 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
646 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
647 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
648         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
649         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
650                 %service -q php-fcgi restart \
651         fi \
652 fi \
653 %{nil}
654
655 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
656 %php4_webserver_restart \
657 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
658 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
659 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
660         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
661         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
662                 %service -q php-fcgi restart \
663         fi \
664 fi \
665 %{nil}
666
667
668 # X.org helper macros
669 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
670 #
671 %xorg_xserver_ansic_abi         %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
672 %xorg_xserver_extension_abi     %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
673 %xorg_xserver_font_abi          %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
674 %xorg_xserver_videodrv_abi      %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
675 %xorg_xserver_xinput_abi        %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
676
677 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
678 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
679 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
680 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
681 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
682 %{__xorg_abi_requires font xorg_xserver_font_abi}
683 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
684 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
685
686 # Python specific macro definitions.
687 # python main version
688 %py_ver                 %(python -c "import sys; print sys.version[:3]")
689
690 # directories
691 %py_prefix              %(python -c "import sys; print sys.prefix")
692 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
693 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
694 %py_incdir              /usr/include/python%{py_ver}
695 %py_sitedir             %{py_libdir}/site-packages
696 %py_sitescriptdir %{py_scriptdir}/site-packages
697 %py_dyndir              %{py_libdir}/lib-dynload
698
699 # pure python modules compilation
700 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
701
702 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
703
704 # Software written in Python language require Python with main version
705 %pyrequires_eq() Requires:      %1
706
707 # Hardlink binary identical .pyc and .pyo files
708 # (idea by glen <at> pld-linux <dot> org)
709 %__spec_install_post_py_hardlink {\
710 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
711 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
712         b="${a%.pyc}.pyo"; \
713         if cmp -s "$a" "$b"; then \
714                 ln -f "$a" "$b"; \
715         fi; \
716 done \
717 }; __spec_install_post_py_hardlink } }
718
719 # remove python sources, so that check-files won't complain
720 # (idea by glen <at> pld-linux <dot> org)
721 %py_postclean() \
722 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
723  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
724 done \
725 %{nil}
726
727 # depmod macro
728 %depmod() { \
729 umask 022; \
730 if [ -e /boot/System.map-%1 ]; then \
731         /sbin/depmod -a -F /boot/System.map-%1 %1; \
732 else \
733         if [ -e /boot/System.map ]; then \
734                 /sbin/depmod -a -F /boot/System.map %1; \
735         else \
736                 /sbin/depmod -a %1; \
737         fi \
738 fi; \
739 }
740
741 # XMMS specific macros
742 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
743 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
744 %xmms_version                   %(xmms-config --version 2>/dev/null)
745 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
746 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
747 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
748 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
749 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
750 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
751 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
752
753 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
754
755 # user/group checking macros
756 #
757 # Usage:
758 #       %userremove myuser
759 #
760 %userremove     /usr/lib/rpm/user_group.sh user del
761 %groupremove    /usr/lib/rpm/user_group.sh group del
762 #
763 # Usage:
764 #       if %usertestrm myuser; then
765 #               /usr/sbin/userdel -r myuser
766 # Note:
767 #       use these macros only if you need to call userdel/groupdel with
768 #       a non-standard option or take an extra action; otherwise use the
769 #       %userremove/%groupremove macros
770 #
771 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
772 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
773 # user group membership management macros
774 #
775 # Usage:
776 #       %addusertogroup myuser agroup
777 #
778 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
779
780 # banner support (useful in {pre,post}{,un} and triggers)
781 #
782 # Usage:
783 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
784 # the banner text, the banner text
785 # the banner text, and following line
786 #EOF
787 # You can use any form of here-document, <<'EOF' <<-EOT will do.
788 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
789 #
790 # -a   - append to the banner
791 # -e   - send to stderr instead of stdout
792 # -n   - no show banner (overrides -t)
793 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
794 #
795 # Tests:
796 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
797 # rpm -E 'date | %banner -e banner' > m; sh -x m
798 #
799 %banner(aent:) ( \
800 RPM_SCRIPTVERBOSITY=5 \
801 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
802 if [ -x /usr/bin/banner.sh ]; then \
803         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
804 else \
805         CMD="cat%{-e: >&2}" \
806 fi \
807 eval $CMD %{?2:%2}%{?3: %3}) \
808 %{nil}
809
810 # useradd/groupadd macros
811 # Author: Elan Ruusamäe <glen@pld-linux.org>
812 #
813 # Usage:
814 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
815 #   [-g initial_group] [-G group[,...]] login
816 #
817 #  -u uid. REQUIRED
818 #  -g gid/group. REQUIRED
819 #  -s defaults to /bin/false
820 #  -d defaults to /usr/share/empty
821 #  -c No default
822 #  -r is accepted but ignored (it's always set)
823 #  -k skeleton dir. defaults to /usr/share/empty
824 # rpm specific flags
825 #  -P package name. defaults to %{name}
826 #
827 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
828 %{!-u:%{error:useradd: Required argument -u missing}} \
829 %{!-g:%{error:useradd: Required argument -g missing}} \
830 %{!?1:%{error:useradd: Required parameter login missing}} \
831 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
832         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
833                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
834                 exit 1 \
835         fi \
836 else \
837         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
838         /usr/sbin/useradd \\\
839                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
840                 -u %{-u*} \\\
841                 -r \\\
842                 -d %{-d*}%{!-d:/usr/share/empty} \\\
843                 -s %{-s*}%{!-s:/bin/false} \\\
844                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
845                 -g %{-g*} \\\
846                 %{-M} \\\
847                 %{-G:-G %{-G*}} \\\
848                 %{expand:%{%{#}}} 1>&2 || exit $? \
849         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
850 fi;
851
852 # Usage:
853 #   %groupadd [-P package] [-g gid] group
854 #
855 # -g gid. REQUIRED
856 #
857 # Sample:
858 #   %groupadd -P %{name}-base -g %{gid} %{name}
859
860 %groupadd(g:P:rfo)      \
861 %{!-g:%{error:groupadd: Required argument -g missing}} \
862 %{!?1:%{error:groupadd: Required parameter group missing}} \
863 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
864         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
865                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
866                 exit 1 \
867         fi \
868 else \
869         echo "Adding group %{1} GID=%{-g*}." \
870         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
871         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
872 fi;
873
874 # webapp macros
875 # Author: Elan Ruusamäe <glen@pld-linux.org>
876 #
877 # The config is installed/removed inside trigger, this means that you can any
878 # time install apache1/apache/lighttpd package and the configuration file is
879 # updated. if you don't need the config for various reason for specific
880 # webserver, just remove the symlink from config directory using webapp
881 # program. the trigger will not recreate the symlink on upgrades. In other
882 # words the config is linked to webserver config directory on first install of
883 # PACKAGE or WEBSERVER.
884 #
885 # Add package's webserver config to webserver webapps dir.
886 # Usage:
887 #   %webapp_register WEBSERVER WEBAPP
888 #
889 %webapp_register() \
890 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
891 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
892         /usr/sbin/webapp register %1 %2\
893 fi\
894 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
895 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
896         %{expand:%service -q %%1 reload}\
897 fi\
898 %{nil}
899
900 # Remove package's config from webserver webapps dir.
901 # Usage:
902 #   %webapp_register [-f] WEBSERVER WEBAPP
903 %webapp_unregister(f) \
904 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
905 # remove link if either of the packages are gone \
906 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
907         /usr/sbin/webapp unregister %1 %2\
908         %{expand:%service -q %%1 reload}\
909 fi \
910 %{nil}
911
912 # service macro.
913 # Author: Elan Ruusamäe <glen@pld-linux.org>
914 #
915 # calls usual service restart on package %post, but skips the restart if
916 # administrator has disabled automatic service restarts in either global
917 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
918 #
919 # Usage:
920 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
921 #
922 #  -q be silent when service isn't started (for scriplets restaring other package's services)
923 #
924 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
925
926
927 # Java macros. based on jpackage macros.java
928 #
929 # Root directory where all Java VMs/SDK/JREs are installed.
930 %_jvmdir                %{_libdir}/jvm
931
932 # Root directory where all Java VMs/SDK/JREs expose their jars
933 %_jvmjardir             %{_libdir}/jvm-exports
934
935 # Root directory for all Java VM/SDK/JRE's private things.
936 %_jvmprivdir    %{_libdir}/jvm-private
937
938 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
939 %_jvmlibdir             %{_libdir}/jvm
940
941 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
942 %_jvmdatadir    %{_datadir}/jvm
943
944 # Root directory for all configurations parts of Java VM/SDK/JRE's
945 %_jvmsysconfdir %{_sysconfdir}/jvm
946
947 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
948 %_jvmcommonlibdir       %{_libdir}/jvm-common
949
950 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
951 %_jvmcommondatadir      %{_datadir}/jvm-common
952
953 # Root directory for all common configurations parts of Java VM/SDK/JRE's
954 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
955
956 # Directory where arch-specific (JNI) version-independent jars are installed.
957 %_jnidir                %{_libdir}/java
958
959 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
960
961 %ant                    JAVA_HOME=%{java_home} ant
962 %jar                    %{java_home}/bin/jar
963 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
964 %javac                  %{java_home}/bin/javac
965 %javadoc                %{java_home}/bin/javadoc
966
967 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
968
969 %jpackage_script() \
970 install -d $RPM_BUILD_ROOT%{_bindir}\
971 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
972 #!/bin/sh\
973 #\
974 # %{name} script\
975 # JPackage Project <http://www.jpackage.org/>\
976 \
977 # Source functions library\
978 . %{_javadir}-utils/java-functions\
979 \
980 # Source system prefs\
981 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
982     . %{_sysconfdir}/java/%{name}.conf\
983 fi\
984 \
985 # Source user prefs\
986 if [ -f $HOME/.%{name}rc ]; then\
987     . $HOME/.%{name}rc\
988 fi\
989 \
990 # Configuration\
991 MAIN_CLASS=%1\
992 BASE_FLAGS=%2\
993 BASE_OPTIONS=%3\
994 BASE_JARS="%(echo %4 | tr ':' ' ')"\
995 \
996 # Set parameters\
997 set_jvm\
998 set_classpath $BASE_JARS\
999 set_flags $BASE_FLAGS\
1000 set_options $BASE_OPTIONS\
1001 \
1002 # Let's start\
1003 run "$@"\
1004 EOF
1005
1006 # jpackage 1.7
1007 # Directory for maven depmaps
1008 #
1009 %_mavendepmapdir /etc/maven
1010 %_mavendepmapfragdir /etc/maven/fragments
1011
1012 #
1013 # add_to_depmap adds an entry to the depmap. The arguments are:
1014 #
1015 # %1 the original groupid
1016 # %2 the original artifact id
1017 # %3 the version
1018 # %4 the new groupid
1019 # %5 the new artifactid
1020 #
1021
1022 %add_to_maven_depmap() \
1023 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1024 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1025 <dependency>\
1026     <maven>\
1027         <groupId>%1</groupId>\
1028         <artifactId>%2</artifactId>\
1029         <version>%3</version>\
1030     </maven>\
1031     <jpp>\
1032         <groupId>%4</groupId>\
1033         <artifactId>%5</artifactId>\
1034         <version>%3</version>\
1035     </jpp>\
1036 </dependency>\
1037 \
1038 EOF\
1039 %{nil}
1040
1041 #==============================================================================
1042 #
1043 # update_maven_depmap updates the main maven depmap
1044 #
1045 %update_maven_depmap() \
1046 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1047 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1048 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1049 fi\
1050 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1051
1052
1053 # PEAR install macros
1054 # Author: Elan Ruusamäe <glen@pld-linux.org>
1055 #
1056 # Usage:
1057 #       %%pear_package_setup [-a #] [-n FMT]
1058 #
1059 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1060 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1061 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1062 #
1063 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1064 # destination hierarchy. you should copy the tree to buildroot after
1065 # patching/reorganizing with %%pear_package_install.
1066 #
1067 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1068 # line endings.
1069 #
1070 # the pear install process output is recorded to install.log, you should put it
1071 # to %%doc for later debug or just for information.
1072 #
1073 # additionally additional-packages.txt is produced if it was detected that the
1074 # package has optional dependencies. the file format is suitable of displaying
1075 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1076 # automatically added for this file.
1077
1078
1079 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1080 %__pear_install_log \
1081 tee install.log \
1082 # make post message of optional packages \
1083 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1084 if [ -s optional-packages.txt ]; then \
1085         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1086 else \
1087         rm -f optional-packages.txt \
1088 fi \
1089 %{nil}
1090
1091 # command invoking pear cli
1092 %__pear /usr/bin/pear
1093
1094 %pear_install(a:n:zD) \
1095 %__pear \\\
1096         -c pearrc \\\
1097         -d doc_dir=/docs \\\
1098         -d php_dir=%{php_pear_dir} \\\
1099         -d bin_dir=%{_bindir} \\\
1100         -d data_dir=%{php_pear_dir}/data \\\
1101         -d test_dir=%{php_pear_dir}/tests \\\
1102         install \\\
1103         --packagingroot=%{builddir} \\\
1104         --offline \\\
1105         --nodeps \\\
1106         %{-f:--force} \\\
1107         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1108 %{nil}
1109
1110 # The main macro.
1111 # using this macro will append optional-packages.txt to the nocompressdoc list
1112 # as it's displayed to user after package install. and adding additional gzip
1113 # dep is just waste ;)
1114 %pear_package_setup(a:n:zD) \
1115 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1116 %define builddir %{_builddir}/%{srcdir} \
1117 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1118 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1119 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1120 %pear_install \
1121 %{-z:cd ..} \
1122 cat %{-z:$_N/}.install.log | %__pear_install_log \
1123 \
1124 # undos sources \
1125 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1126 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1127 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1128 %{nil}
1129
1130 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1131 # Author: Elan Ruusamäe <glen@pld-linux.org>
1132 %pear_package_install() \
1133 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1134 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1135 # help the developer out a little: \
1136 if [ -f _noautoreq ]; then \
1137         echo "AutoReqdep detected:" \
1138         echo "_noautoreq $(cat _noautoreq)" \
1139 fi \
1140 %{nil}
1141
1142
1143 # Register OpenLDAP schema.
1144 # Author: Elan Ruusamäe <glen@pld-linux.org>
1145 #
1146 # Usage:
1147 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1148 #
1149 #  -d specify dependant schemas, separated by comma
1150 #
1151 %openldap_schema_register(d:) \
1152 for schema in %*; do \
1153         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1154                 %{__sed} -i -e " \
1155                         /^include.*local.schema/{ \
1156                                 iinclude\\t     $schema\
1157                         } \
1158                 " /etc/openldap/slapd.conf \
1159         fi \
1160 done \
1161 # enable dependant schemas \
1162 if [ "%{-d*}" ]; then \
1163         %{__sed} -i -e ' \
1164         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1165                 s/^#// \
1166         }' /etc/openldap/slapd.conf \
1167 fi \
1168 %{nil}
1169
1170 # Unregister OpenLDAP schema.
1171 # Author: Elan Ruusamäe <glen@pld-linux.org>
1172 #
1173 # Usage:
1174 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1175 #
1176 %openldap_schema_unregister() \
1177 for schema in %*; do \
1178         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1179                 %{__sed} -i -e " \
1180                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1181                 # for symmetry it would be nice if we disable enabled schemas in post, \
1182                 # but we really can not do that, it would break something else. \
1183                 " /etc/openldap/slapd.conf \
1184         fi \
1185 done \
1186 %{nil}
1187
1188 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1189
1190
1191 # Build modules for kernels 2.6
1192 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1193 #
1194 # Usage:
1195 #       %build_kernel_modules -m <modules> -C <directory>
1196 #
1197 #  remember that proper Makefile is still required
1198 # Options:
1199 #  -m <modules> (required) -- comma-separated list of modules to save,
1200 #               without .ko extension, may be placed in subdirectory
1201 #  -C <directory> -- change to <directory> before doing anything
1202 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1203 #  -c -- do not execute make clean
1204 #  <additional arguments> -- all additional arguments will be passed to
1205 #               make modules
1206 #
1207 # Additional patching supported via here document. Try:
1208 #       %build_kernel_modules -m module <<'EOF'
1209 #       your patch script here
1210 #       EOF
1211 # Don't use it unless patching depends on config options.
1212
1213 # Developer note: don't touch it unless you know how to handle '\'.
1214 # - \ in script expands to nothing
1215 # - \\\ in script expands to \
1216 # - \\\ inside definition expands to nothing
1217 # - \\\\\\\ inside definition expands to \
1218 # - in last line \ has to touch arguments so arguments passing
1219 #   in new lines (using \) will be supported
1220
1221 %build_kernel_modules(p:P:m:C:c)                                                                        \
1222 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1223                                                                                                                                         \
1224 %define Opts                                                                                                            \\\\\\\
1225 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1226         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1227         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1228         %else                                                                                                                   \\\
1229         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1230         %endif                                                                                                                  \\\
1231 %else                                                                                                                           \\\
1232         CC="%{kgcc}"                                                                                                    \\\
1233 %endif                                                                                                                          \
1234 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1235                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1236                                                                                                                                         \
1237 %{?-C:cd %{-C*}}                                                                                                        \
1238 compile() {                                                                                                                     \
1239         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1240         set -e -x                                                                                                               \
1241         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1242                                                                                                                                         \
1243 for cfg in ${cfgs:-dist}; do                                        \
1244         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1245                                                                                                                                         \
1246         rm -rf o                                                                                                                \
1247         install -d o/include/linux                                                                              \
1248         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1249         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1250         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1251                                                                                                                                         \
1252         set +x                                                                                                                  \
1253         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1254         set -x                                                                                                                  \
1255                                                                                                                                         \
1256         %if %{with dist_kernel}                                                                                 \
1257                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1258                         %{-p*} %{-P*}                                                                                   \\\
1259                         %{MakeOpts}                                                                                             \
1260         %else                                                                                                                   \
1261                 install -d o/include/config                                                                     \
1262                 touch o/include/config/MARKER                                                           \
1263                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1264         %endif                                                                                                                  \
1265                                                                                                                                         \
1266         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1267                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1268                 M=$PWD %{MakeOpts}}                                                                                     \
1269         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1270                 ${1+"$@"}                                                                                                       \\\
1271                 M=$PWD %{MakeOpts}                                                                                      \
1272                                                                                                                                         \
1273         for MODULE in {%{-m*},}; do                                                                             \
1274                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1275         done                                                                                                                    \
1276 done                                                                                                                            \
1277 %{?-C:cd -}                                                                                                                     \
1278 }                                                                                                                                       \
1279 compile %{*}\
1280 %{nil}
1281
1282
1283 # Install kernel modules built by %build_kernel_modules
1284 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1285 #
1286 # Usage:
1287 #       %install_kernel_modules -m <modules> -d <directory>
1288 #
1289 # Options:
1290 #  -m <modules> (required) -- comma-separated list of modules to install,
1291 #               without .ko extension, may be placed in subdirectory
1292 #  -d <directory> (required) -- in what subdirectory modules should be
1293 #               installed (eg. misc, kernel/drivers/net)
1294 #  -s <suffix> -- suffix to use when installing modules, useful when module
1295 #               with same name exists in kernel already
1296 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1297 #               for defining aliases, only useful with -s
1298
1299 %install_kernel_modules(m:d:s:n:)                                                                       \
1300 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1301 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1302 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1303                                                                                                                                         \
1304 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1305 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1306                                                                                                                                         \
1307 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1308                                                                                                                                         \
1309 for MODULE in {%{-m*},}; do                                                                                     \
1310         [ -n "${MODULE}" ] || continue                                                                  \
1311         for cfg in ${cfgs:-dist}; do                                    \
1312                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1313                 MNAME=${MODULE##*/}                                                                                     \
1314                 install -D ${MODULE}-$cfg.ko                                                            \\\
1315                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1316                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1317                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1318                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1319         done                                                                                                                    \
1320 done                                                                                                                            \
1321 %{nil}
1322
1323 # patchset macros
1324 # Author: Elan Ruusamäe <glen@pld-linux.org>
1325 #
1326 # Usage:
1327 #   %patchset_source -f <seq(1) format> <start> [<end>]
1328 #   %patchset_patch <start> [<end>]
1329 #
1330 # If <end> is omited, it is assumed to be <start>.
1331 #
1332 # For example in preamble:
1333 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1334 # and in %prep:
1335 #  %patchset_patch 33 44
1336
1337 # generate SourceX urls from range START STOP
1338 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1339 # The sources start from 10000
1340 %patchset_source(f:b:) %(
1341         base=%{-b*}%{!-b*:10000};
1342         start=$(expr $base + %1);
1343         end=$(expr $base + %{?2}%{!?2:%{1}});
1344         # we need to call seq twice as it doesn't allow two formats
1345         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1346         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1347         paste %{tmpdir}/__ps{1,2};
1348         rm -f %{tmpdir}/__ps{1,2};
1349 ) \
1350 %{nil}
1351
1352 # apply sources from %patchset_source
1353 # -p specify -pX for %patch line
1354 # -b base offset: defaults to 10000
1355 %patchset_patch(f:p:b:) %(
1356         base=%{-b*}%{!-b*:10000};
1357         start=$(expr $base + %1);
1358         end=$(expr $base + %{?2}%{!?2:%{1}});
1359         echo ": patchset_patch %1%{?2: to %2}";
1360         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1361 ) \
1362 %{nil}
1363
1364 # browser plugins v2
1365 # Author: Elan Ruusamäe <glen@pld-linux.org>
1366 #
1367 # Usage:
1368 #       %browser_plugins_add_browser <name> -p <plugindir>
1369 #
1370 #  <name> (required) -- name of the browser. usually %{name}.
1371 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1372 #  -b -- default blacklists
1373 #  -a <arch> override arch
1374 #
1375 # Example:
1376 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1377
1378 %_browserpluginsconfdir         /etc/browser-plugins
1379 %_browserpluginsdir                     %{_libdir}/browser-plugins
1380 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1381
1382 %browser_plugins_add_browser(p:b:a:) \
1383         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1384         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1385         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1386         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1387         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1388         %{-b:cat >> $blacklist_file %{-b*}} \
1389 %{nil}
1390
1391 # Helper for LUA.
1392 # split string separated by space into quoted list
1393 #
1394 # Author: Elan Ruusamäe <glen@pld-linux.org>
1395 #
1396 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1397 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1398
1399 # adjust /etc/shells by adding and removing shells from there
1400 # Author: Elan Ruusamäe <glen@pld-linux.org>
1401 #
1402 # Usage:
1403 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1404 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1405 #
1406 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1407
1408 %add_etc_shells(p) %{-p:<lua>}\
1409 t = {}\
1410 f = io.open("/etc/shells", "r")\
1411 if f then\
1412         for l in f:lines() do t[l]=l; end\
1413         f:close()\
1414 end\
1415 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1416         if not t[s] then\
1417                 print("Adding "..s.." to /etc/shells")\
1418                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1419         end\
1420 end\
1421 %{nil}
1422
1423 %remove_etc_shells(p) %{-p:<lua>}\
1424 %{-p:if arg[2] == 0 then}\
1425         t = {}\
1426         f = io.open("/etc/shells", "r")\
1427         if f then\
1428                 for l in f:lines() do t[l]=l; end\
1429                 f:close()\
1430         end\
1431         for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1432                 print("Removing "..l.." from /etc/shells")\
1433                 t[l] = nil\
1434         end\
1435         s=""\
1436         for _, l in pairs(t) do\
1437                 s=s..l.."\\n"\
1438         end\
1439         io.open("/etc/shells", "w"):write(s)\
1440 %{-p:end} \
1441 %{nil}
1442
1443 # vim:ts=4 sw=4 noet syn=spec
This page took 0.370014 seconds and 4 git commands to generate.